public class CodaPratiche {
 private Nodo head;
 private Nodo tail;
 private int codice;
 
 public CodaPratiche() {
  head = null;
  tail = null;
  codice=0;
 }
 
 private Nodo creaNodo(Pratica pratica, Nodo link) {
  codice++;
  pratica.setCodice(codice);
  Nodo p = new Nodo(pratica);
  p.setLink(link);
  return p;
 }

 public void inserisciPratica(Pratica pratica) {
  Nodo p = creaNodo(pratica, null);
  if (head==null){ // coda vuota?
   tail=p;
   head=tail;
  }
  else {
  tail.setLink(p);
  tail = p;
  }
 }
 
 public Pratica evadiPratica() throws PraticheException {
  Nodo p;
  if (head==null) // coda vuota?
      throw new PraticheException("Coda pratiche vuota!");
  p = head;
  head = head.getLink();
  if (head==null) // ultimo elemento della coda?
   tail=null;
  return p.getInfo();
 }
 
 
 public int contaPratiche(String tipo){
    Nodo p=head;
    int conta=0;
    if (p==null) 
        return conta;
    while (p!=null){
        if(tipo.equals("*"))
            conta++;
        else if (p.getInfo().getTipo().equals(tipo))
            conta++;
         p=p.getLink();
    }
    return conta; 
 }
 
 public Pratica[] inventarioPraticaPerTipo(String tipo){
   int i=0;  
   int conta=contaPratiche(tipo);
   Pratica inventario[]=new Pratica[conta];
   Nodo p=head;
   while (p!=null){
        if(tipo.equals("*"))
           inventario[i++]=new Pratica(p.getInfo());
        if (p.getInfo().getTipo().equals(tipo))
            inventario[i++]=new Pratica(p.getInfo());       
         p=p.getLink();
    }
   return inventario;
 }
 
 public Pratica eliminaPratica(int codice) throws PraticheException {
    Nodo pp,p;
    p=head;
    if (p==null) 
        throw new PraticheException("Coda pratiche vuota!");
    pp=p;
    while (p!=null){
        if(p.getInfo().getCodice()==codice){
         if (p==head)
             head=head.getLink();
         else if(p.getLink()==null){
             pp.setLink(null);
             tail=pp;
         }
         else
            pp.setLink(p.getLink());
         return p.getInfo();       
        }  
        pp=p;      
        p=p.getLink();
    }
    throw new PraticheException("Codice inesistente!");
 } 
    
  public Pratica cercaPratica(int codice) throws PraticheException {
    Nodo p=head;
    if (p==null) 
      throw new PraticheException("Coda pratiche vuota!");
    while (p!=null){
      if(p.getInfo().getCodice()==codice)
          return p.getInfo();            
      p=p.getLink();
    }  
    throw new PraticheException("Codice inesistente!");
 }
    
 public String toString() {
  Nodo p = head;
  String lista;
  if (p==tail) // coda di un solo elemento?
   lista = new String("head/tail->");
  else
   lista = new String("head->");
  if (p==null)
   return lista + "null";
  while (p!=null) {
   lista = lista+"[" + p.getInfo().toString() + "|";
   if (p.getLink()==tail)
    lista = lista + "+]-(tail)->";
   else {
    if (p.getLink()==null)
     lista = lista + "null]";
    else
     lista = lista + "+]->";
  }
  p = p.getLink();
 }
 return lista;
}

 public static void main (String[] args) {
  Pratica p1 = new Pratica("Bianchi Giovanni","A","Pratica richiesta rimborso spese");
  Pratica p2 = new Pratica("Rossi Marta","B","Pratica per richiesta permesso retribuito");
  Pratica p3= new Pratica("Neri Alberto","B","Pratica per richiesta permesso retribuito");
  CodaPratiche coda = new CodaPratiche();
  coda.inserisciPratica(p1);
  coda.inserisciPratica(p2);
  coda.inserisciPratica(p3);
  Pratica inventario[]=coda.inventarioPraticaPerTipo("*");
  for (int i=0; i<inventario.length;i++)
     System.out.println (inventario[i].toString());
  System.out.println(coda);
  try {
    Pratica pratica_evasa = coda.evadiPratica();
    System.out.println("Prossima pratica: "+pratica_evasa.toString());
  }
  catch (PraticheException e) {
      System.out.println(e.getError());
  }
  try {
    Pratica pratica_evasa = coda.evadiPratica();
    System.out.println("Prossima pratica: "+pratica_evasa.toString());
  }
  catch (PraticheException e) {
      System.out.println(e.getError());
  }
  
 }
}