public class ProntoSoccorso {
 private Nodo head;
 private int elementi;
 private int bianchi;
 private int gialli;
 private int rossi;
 
 public ProntoSoccorso() {
  head = null;
  elementi=0;
 }
 
 private Nodo getLinkPosizione(int posizione) throws ProntoSoccorsoException {
  int n = 1;
  Nodo p = head;
  if (head==null)
   throw new ProntoSoccorsoException("Lista vuota");
  if ((posizione>elementi) || (posizione<1))
   throw new ProntoSoccorsoException("Posizione errata");
  while ((p.getLink()!=null) && (n<posizione)) {
   p = p.getLink();
   n++;
  }
  return p;
}
 
 private Nodo creaNodo(Paziente paziente, Nodo link) {
   Nodo nuovoNodo = new Nodo(paziente);
   nuovoNodo.setLink(link);
   return nuovoNodo;
 }

 public int getElementi() {
  return elementi;
 }

 public void aggiornaCodici(Paziente paziente,int n){
    if (paziente.getCodice().equals("Bianco"))
       bianchi+=n;
   else if (paziente.getCodice().equals("Giallo"))
       gialli+=n;
   else if (paziente.getCodice().equals("Rosso"))
       rossi+=n;
   elementi+=n; 
 }
 public void inserisciInTesta(Paziente paziente) {
   Nodo p = creaNodo(paziente, head);
   head = p;
   aggiornaCodici(paziente,1);
   return;
 }
 
 public void inserisciInCoda(Paziente paziente) {
  if (head==null)
   inserisciInTesta(paziente);
  else {
    try {
      Nodo p = getLinkPosizione(elementi);
      p.setLink(creaNodo(paziente, null));
      aggiornaCodici(paziente,1);
   }
  catch (ProntoSoccorsoException exception){
  }
  return;
  }
 }
 
 public void inserisciInPosizione(Paziente paziente, int posizione) throws ProntoSoccorsoException {
     if (posizione<=1)
       inserisciInTesta(paziente);
     else {
       if (elementi<posizione)
         inserisciInCoda(paziente);
       else {
         Nodo p = getLinkPosizione(posizione-1);
         p.setLink(creaNodo(paziente, p.getLink()));
         aggiornaCodici(paziente,1);
    }
  }
  return;
 } 
 
public void eliminaInTesta() throws ProntoSoccorsoException {
 if (head==null)
   throw new ProntoSoccorsoException("Lista vuota");
   aggiornaCodici(head.getInfo(),-1);
   head=head.getLink();
   return;
 }

 public void eliminaInCoda() throws ProntoSoccorsoException {
  if (head==null)
    throw new ProntoSoccorsoException("Lista vuota");
  Nodo p=getLinkPosizione(elementi-1);
  aggiornaCodici(p.getLink().getInfo(),-1);
  p.setLink(null);
  return;
 }
 
 public void eliminaInPosizione(int posizione) throws ProntoSoccorsoException {
  if (posizione==1)
    eliminaInTesta();
  else
   if (posizione==elementi)
     eliminaInCoda();
   else {
     Nodo ps = getLinkPosizione(posizione);
     Nodo pp = getLinkPosizione(posizione-1);
     pp.setLink(ps.getLink());
     aggiornaCodici(ps.getInfo(),-1);
  }
  return;
 }
 
 public Paziente estraiPaziente() throws ProntoSoccorsoException{
  if (head==null)
   throw new ProntoSoccorsoException("Lista vuota");
  Nodo p=head;
  int posizione=1;
  Paziente pe=null;
  String tipocodice;
  if (rossi>0)
      tipocodice="Rosso";
  else if (gialli>0)
      tipocodice="Giallo";
  else 
      tipocodice="Bianco";
  while (p!=null)
      if (p.getInfo().getCodice().equals(tipocodice))
          break;
      else {
        posizione++;
        p=p.getLink();
      }    
  if (p!=null){
      pe=new Paziente(p.getInfo());
      eliminaInPosizione(posizione);
  }
  return pe;
 }
 
 private String visita(Nodo p) {
  if (p==null)
   return "";
  return p.getInfo().toString()+"\n"+visita(p.getLink());
 }
 
 public String elenco() {
  return visita(head);
 }
 
 public String toString() {
  Nodo p = head;
  String lista = new String("head->");
  if (p==null)
   return lista+"null";
  while (p!=null) {
   lista = lista+"["+p.getInfo().toString()+"|";
   if (p.getLink()==null)
    lista = lista+"null]";
   else
    lista = lista+"+]->";
    p = p.getLink();
  }
  return lista;
 }
 
}