public class TabellaInvitati {
 private Invitato festa[]; // tabella
 private int numeroInvitati;
 
 public TabellaInvitati(int dimensione) {
   festa = new Invitato[dimensione];
   numeroInvitati=0;
 }
// funzione hash
 private int hash (String chiave) {
   int p = 0;
   for (int i=0; i<chiave.length(); i++) {
     p += chiave.charAt(i);
   }
   return (p % festa.length);
 }
 
// operazione R = ricerca per informazioni
// operazione I = ricerca per inserimento
 private int cercaInvitato(String chiave, char operazione) throws TabellaException {
     int p = hash(chiave);
     if (operazione == 'R') {
     // ricerca per informazioni
      if (festa[p] == null)
       throw new TabellaException( "Elemento "+chiave+ " non esistente");
      if (festa[p].getNome().equals(chiave))
       return p;
     }
     else {
     // ricerca per inserimento
      if (festa[p] == null)
       return p;
      if (festa[p].getNome().equals(chiave))
        throw new TabellaException( "Elemento "+festa[p].getNome()+ " preesistente");
     }
     // collisione -> scansione lineare
     p = scansioneLineare(p, chiave, operazione);
     return p;
 }
 public Invitato cerca(String nome) throws TabellaException {
   int p = cercaInvitato(nome,'R');
   return new Invitato(festa[p]);
 }
 public int getNumeroInvitati() {
  return numeroInvitati;
 }
 public int inserisciInvitato(Invitato persona) throws TabellaException {
  String chiave = persona.getNome();
  int p = cercaInvitato(chiave, 'I');
  festa[p] = new Invitato(persona);
  numeroInvitati++;
  return p;
}
public int eliminaInvitato(String nome) throws TabellaException {
  int p = cercaInvitato(nome, 'R');
  festa[p] = null;
  numeroInvitati--;
  return p;
}
// funzione di visualizzazione dello stato corrente
// utilizzata a scopo di test
public void visualizzaStatoTabella() {
  for (int i=0; i<festa.length; i++)
  if (festa[i] != null)
  System.out.println("Posizione "+i+"->"+festa[i].toString()+"(hash: "+hash(festa[i].getNome())+")");
}
private int scansioneLineare ( int posizioneIniziale, String chiave,char operazione) throws TabellaException {
  int p = posizioneIniziale;
  while (true) {
   p++;
   p = p % festa.length;
   if (operazione == 'R') {
   // ricerca per informazione
    if (festa[p] == null)
     throw new TabellaException( "Elemento "+chiave+ " non esistente");
    if (festa[p].getNome().equals(chiave))
    return p;
   }
   else {
   // ricerca per inserimento
    if (festa[p] == null)
    return p;
    if (festa[p].getNome().equals(chiave))
      throw new TabellaException( "Elemento "+festa[p].getNome()+ " preesistente");
  }
  if (p == posizioneIniziale)
   if (operazione == 'R')
    throw new TabellaException( "Elemento "+chiave+ " non esistente");
   else
   throw new TabellaException("Tabella piena");
  }
}
public static void main (String[] args) {
 Invitato i1 = new Invitato("Bianchi Giovanni",'M',"0586 854822");
 Invitato i2 = new Invitato("Rossi Marta",'F',"0586 844853");
 Invitato i3 = new Invitato("Neri Marco",'M',"0586 444722");
 Invitato i4 = new Invitato("Verdi Roberta",'F',"0586 974824");
 Invitato i5 = new Invitato("Marti Rossa",'F',"0586 864253");
 TabellaInvitati t = new TabellaInvitati(100);
 try {
   System.out.println("Inserimento invitato " +i1.getNome()+" posizione: "+t.inserisciInvitato(i1));
   System.out.println("Inserimento invitato " +i2.getNome()+" posizione: "+t.inserisciInvitato(i2));
   System.out.println("Inserimento invitato " +i3.getNome()+" posizione: "+t.inserisciInvitato(i3));
   System.out.println("Inserimento invitato " +i4.getNome()+" posizione: "+t.inserisciInvitato(i4));
   System.out.println("Inserimento invitato " +i5.getNome()+" posizione: "+t.inserisciInvitato(i5));
   System.out.println("Inserimento invitato " +i5.getNome()+" posizione: "+t.inserisciInvitato(i5));
 }
 catch (TabellaException e) {
  System.out.println(e.getError());
 }
 System.out.println("Stato tabella:");
 t.visualizzaStatoTabella();
 try {
   System.out.println("Ricerca Marti Rossa: "+ t.cerca("Marti Rossa"));
   System.out.println("Ricerca Pippicalzelunghe: "+ t.cerca("Pippicalzelunghe"));
 }
 catch (TabellaException e) {
   System.out.println(e.getError());
 }
 try {
   System.out.println( "Eliminazione invitato Verdi Roberta in posizione: "+t.eliminaInvitato("Verdi Roberta"));
   System.out.println( "Eliminazione invitato Marti Rossa in posizione: "+t.eliminaInvitato("Marti Rossa"));
   System.out.println( "Eliminazione invitato Verdi Roberta in posizione: "+t.eliminaInvitato("Verdi Roberta"));
 }
 catch (TabellaException e) {
   System.out.println(e.getError());
 }
 System.out.println("Stato tabella:");
 t.visualizzaStatoTabella();
 }
}