import java.io.*;

public class TextFile {
    char mode;
    private BufferedReader reader;
    private BufferedWriter writer;
      
    public TextFile(String filename, char mode) throws IOException {
        this.mode = 'R';
        if (mode == 'W') {
            this.mode = 'W';
            writer = new BufferedWriter(new FileWriter(filename));
          }
        else {
            reader = new BufferedReader(new FileReader(filename));
        }
    }

    public void toFile(String line) throws FileException, IOException {
        if (this.mode == 'R') throw new FileException("Read-only file!");
        writer.write(line);
        writer.newLine();
    }
    
    public String fromFile() throws FileException, IOException {
        String tmp;
        if (this.mode == 'W') throw new FileException("Write-only file!");
        tmp =  reader.readLine();
        if (tmp == null) throw new FileException("End of file!");
        return tmp;
    }
    
    public void closeFile() throws IOException {
        if (this.mode == 'W')
          writer.close();
        else // this.mode == 'R'
            reader.close();
    }
    
    public static void main(String args[]) throws IOException {
        TextFile out = new TextFile("pluto.txt",'W');
        
        try {
            out.toFile("Riga 1");
            out.toFile("Riga 2");
            out.toFile("Riga 3");
        }
        catch (FileException fe) {
            System.out.println(fe.getMatter());
        }
        finally {
            out.closeFile();
        }
        
        TextFile in = new TextFile("pluto.txt",'R');
        String line;
        
        try {
            while (true) {
                line = in.fromFile();
                System.out.println(line);
            }
        }
        catch (FileException e) {
            System.out.println(e.getMatter());
        }
        finally {
            out.closeFile();
        }
    }
}